%let path=C:\SGF2018 - SAS and Big Data;
libname db teradata server=&TDServer user=&TDUser password=&TDPassword
        database=&TDDatabase multistmt=yes dbcommit=20000;
libname sas "&path\data";

%INCLUDE "&path\data\create_BIG_CUSTOMER_DIM.sas";

data sas.narrow;
  do id = 1 to 1e9;
    if mod(id,4)=0 then output;
  end;
run;

%let MaxObs=1000000;
data sas.narrow2;
   call streaminit(123456);
   do id=1 to &maxobs;
      ru=ceil(rand('UNIFORM')*10);
      rn=ceil(rand('NORMAL',1000,200));
      output;
   end;
run;

%macro maxint(maxnum);
 /* Returns the least number of bytes required to store a given integer value */
%local i max;
%do i=2 %to 8;
  %let max=%sysfunc(constant(exactint,&i));
  %if &max ge &maxnum %then %do;
    &i
  %return;
  %end;
%end;
%mend;

%let Groups=99;
data sas.wide;
   /* Make GROUP just long enough to hold the max group number */
   Length ID 8 Group %maxint(&groups);
   array norm[4000] ;
   array uni[4000] ;
   array txt[2000] $ 5;
   call streaminit(123456);
   drop i;
   do Group=1 to &groups;
      do id= group*100 to (group*100)+500;
         do i=1 to dim(norm);
            uni[i]=rand('Uniform');
            norm[i]=ceil(rand('Normal',uni[i]*5000,uni[i]*100));
         end;
         txt[1]=SUBSTRN('ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'
                      ,ceil(uni[1]*52),1);
         do i=2 to dim(txt);
            txt[i]=cats(SUBSTRN('ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'
                         ,ceil(uni[i]*52),1),txt[i-1]);
         end;
         output;
      end;
   end;
run;
